<?php
/*
Plugin Name: myWeather
Version: 2.0b
Plugin URI: http://www.thedeveloperinside.com/

Author: Eduardo
Author URI: http://www.thedeveloperinside.com/

Description: Shows current weather conditions for various cities by weather.com

1. Download
2. Upload this folder to your wp-plugins/ directory
4. Active the MyWeather Plugin in plugin administrate
5. Place this code in your template: 

<?php wp_myweather();?>

6. Use admin for select city:

*/

$plugin_directory = get_option('home')."/wp-content/plugins/myweather/";

function get_cached_file(){
	if(get_option('wp_weather_xml')){
		return get_option('wp_weather_xml');
	}else{
		return false;
	}
}

function save_xml($file){
	if(get_option('wp_weather_xml')){
		update_option('wp_weather_xml',$file);
	}else{
		add_option('wp_weather_xml',$file,'myweather xml');
	}
}
function set_cache($n,$d){
	$f=@fopen($n,"w");
	if (!$f) {
		return false;
	} else {
		fwrite($f,$d);
		fclose($f);
		return true;
	}
}

function search_file_cached($wp_weather_xml){
	$plugin_directory=dirname(__FILE__)."/";
	$wp_weather_cache_temp=get_option('wp_weather_city_cache');
	$file=get_cached_file();
	if(is_file($plugin_directory."cache/".$file)){
		$ext=explode(".",$file);
		if(($ext[0]+$wp_weather_cache_temp)>time()){
			$xml=file_get_contents($plugin_directory."cache/".$file);
		}else{
			unlink($plugin_directory."cache/".$file);
			$xml=file_get_contents($wp_weather_xml);
			$file=time().".xml";
			set_cache($plugin_directory."cache/".$file,$xml);
			save_xml($file);
		}
	}else{
		$xml=file_get_contents($wp_weather_xml);
		$file=time().".xml";
		set_cache($plugin_directory."cache/".$file,$xml);
		save_xml($file);
	}
	return $xml;
}


$struct = array();
function data($parser, $data){
	global $struct;
	if(trim($data)){
		$struct[]=$data;
	}
}

function parsa_data($fdata){
	$file=search_file_cached($fdata);
	$xml_parser = xml_parser_create();
	xml_set_character_data_handler($xml_parser, "data");
	$xml=xml_parse($xml_parser,$file);
}

function wp_myweather(){
	global $plugin_directory,$struct;
	$city=get_option('wp_weather_city');
	$t_type=get_option('wp_weather_city_temp');
	if(!$t_type){
		$t_type="C";
	}
	$fdata = "http://xoap.weather.com/weather/local/".$city."?cc=*&dayf=0";

	$xml=parsa_data($fdata);
 

	$locale=$struct[0]; //lingua
	$form=$struct[1]; //
	$ut=$struct[2]; //scala temperatura
	$ud=$struct[3]; //scala distanza
	$us=$struct[4]; //scala velocita/tempo
	$up=$struct[5]; //scala pressione
	$ur=$struct[6]; //
	$city=$struct[7]; //nome citta
	$time=$struct[8]; //orario
	$lat=$struct[9]; //latitudine
	$lon=$struct[10]; //longitudine
	$suns=$struct[11]; //alba
	$sunr=$struct[12]; //tramonto
	$zone=$struct[13]; //zona
	$lsup=$struct[14]; //data rilevamento
	$obst=$struct[15]; //osservatorio
	$tmp=$struct[16]; //temperatura
	$flik=$struct[17]; //flik
	$weather=$struct[18]; //tempo
	$icon=$struct[19]; //icona tempo
	$bar_r=$struct[20]; //pressione
	$bar_d=$struct[21]; //tipo pressione
	$wind_s=$struct[22]; //velocità vento
	$wind_gust=$struct[23]; //raffica 
	$wind_d=$struct[24]; //
	$wind_t=$struct[25]; //direzione vento (N,S,E,W)
	$hmid=$struct[26]; //umidità in %
	$vis=$struct[27]; //visibilità (distanza)
	$uv_i=$struct[28]; // raggi uv
	$uv_t=$struct[29]; // tipo raggi
	$dewp=$struct[30]; //Punto di rugiada (in temp)
	$moon_icon=$struct[31]; //icona luna
	$moon_t=$struct[32]; //tipo luna
    
    list($city)=explode(",",$city);
	list($city)=explode("/",$city);
    
	switch($t_type){
		default:
		case "F":
			$tmp=$tmp."&deg;";
			break;
		case "C":
			$tmp=round(($tmp-32)/(1.8))."&deg;";
			break;
	}
    
    switch($icon){
      default:
      case 44:
			$icon=0;
			break;
      case 5:
      case 8:
      case 9:
      case 11:
			$icon=1;
			break;
      case 15:
      case 25:
			$icon=2;
			break;
      case 20:
			$icon=3;
			break;
      case 32:
      case 36:
			$icon=4;
			break;
      case 19:
      case 21:
      case 22:
			$icon=5;
			break;
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 17:
      case 35:
      case 37:
      case 38:
      case 47:
			$icon=6;
			break;
      case 39:
			$icon=7;
			break;
      case 13:
			$icon=8;
			break;
      case 23:
      case 24:
			$icon=9;
			break;
      case 14:
			$icon=10;
			break;
      case 14:
      case 16:
      case 18:
      case 41:
      case 42:
      case 43:
      case 46:
			$icon=11;
			break;
      case 10:
      case 12:
      case 40:
      case 45:
			$icon=12;
			break;
      case 26:
			$icon=13;
			break;
      case 6:
      case 7:
			$icon=14;
			break;
      case 28:
      case 30:
      case 34:
			$icon=15;
			break;
      case 27:
      case 29:
      case 31:
      case 33:
			$icon=16;
			break;
    }
	$weather='<div id="wp_myweather"><img src="'.$plugin_directory .'iconset/'.$icon.'.gif" alt="'.$weather.'" /><strong>'.$city.'</strong><em>'.$tmp.'</em></div>';
	print($weather);
	array_shift($struct);
}
function myweather_style() {
	global $plugin_directory;
	print('<link href="'.$plugin_directory.'style.css" rel="stylesheet" type="text/css" />'."\n");
}
// Admin
function myweather_admin() {
	include("admin.myweather.php");
}
function myweather_to_admin() {
	if (function_exists('add_submenu_page')) {
		add_submenu_page('options-general.php', 'myWeather', 'myWeather', 1, basename(__FILE__), 'myweather_admin');
	}
}
add_action('admin_menu','myweather_to_admin');
add_action('wp_head', 'myweather_style', 10);
?>